;---------------------------------------------------------------------------------------------------|
;"Keyb_4_3.inc"    
;---------------------------------------------------------------------------------------------------|
;.equ	LCD_KEY	=1 ;     LCD
;---------------------------------------------------------------------------------------------------|
.equ	PORT_Scan	= PORTd ;PORT   
.equ	DDR_Scan	= DDRd	;DDR    
.equ	PIN_Scan	= PINd	;PIN  
;---------------------------------------------------------------------------------------------------|
;   
;---------------------------------------------------------------------------------------------------|
.equ	s_key1	= 2			; "-"
.equ	s_key2	= 1			; "+"
.equ	s_key3	= 0			; "*"

.equ	keymask	= 1<<s_key3|1<<s_key2|1<<s_key1


.equ	longkey	= 5
.equ	eq_key	= 7
;---------------------------------------------------------------------------------------------------|
.equ	no_key	= 0xFF
.equ	miss_key= 155
;---------------------------------------------------------------------------------------------------|
read4_key:	
			cbr  MainFlags,1<<Sckey_Flag
			in Tmp_A,PIN_Scan
;---------------------------------------------------------------------------------------------------|
;  
; Tmp_A=PIN_Scan   *  1-   2-   >4
;  Key(Tmp_A) 
; "no_key"=255   ,     "eq_key"
;"s_key(n)"   n =1,2,3,4
;"eq_key and s_key(n)"  
;"longkey and s_key(n)"  
;  
; Tmp_A=PIN_Scan   *  1-   2-   >4
;  Key(Tmp_A) 
; "no_key"=255   ,     "eq_key"
;"s_key(n)"   n =1,2,3,4
;"eq_key and s_key(n)"  
;"longkey and s_key(n)"  
			com Tmp_A				; Tmp_A  PIN   0=  1=
			andi Tmp_A,keymask		;  
			tst Tmp_A				; 0   
			brne SetKey0			; 1   
			ldi Tmp_A,no_key		; 0   0xFF ..   
			rjmp Reset_timerkey		;   
SetKey0:							;
			lds Tmp_E,key
			andi Tmp_E,keymask		;   
			cp Tmp_A,Tmp_E			;   
			brne Reset_timerkey		;         
			
			lds Tmp_E,timerkey
			dec Tmp_E			;      

			breq SetKey2			;     longkey
			sbr Tmp_A,1<<eq_key		;  
			rjmp EndKeyRead			;    
SetKey2:      						;
			sbr Tmp_A,1<<longkey	;   4
Reset_timerkey:   					;
			ldi Tmp_E,miss_key		;   
EndKeyRead:							;
			sts timerkey,Tmp_E		;    
			sts key,Tmp_A			;    key
			sbrc Tmp_A,eq_key		;       
			ret						;

;---------------------------------------------------------------------------------------------------|
;  ,   														|
;---------------------------------------------------------------------------------------------------|

			sbrc MainFlags,Alarm_On
			rjmp EndKeyboard
			sbrc ControlFlags,Br_disp;off_disp
			rjmp EndKeyboard
beginKeyboard:
			cpi Tmp_A,1<<longkey|1<<s_key3
			brne Key_B
			sbrc ControlFlags,Lock_Set
			ret
		ldi Tmp_E,62
		sts Tone,Tmp_E
			ldi music_Delay,24
			rcall soundon
			sbr ControlFlags,(1<<Lock_Set)|(1<<CtrlSet)
			rjmp EndKeyboard1				
Key_B:

			cpi Tmp_A,1<<longkey|1<<s_key2
			brne Key_A
			sbrc ControlFlags,Lock_Set
			ret
		ldi Tmp_E,62
		sts Tone,Tmp_E
			ldi music_Delay,24
			rcall soundon
			sbr ControlFlags,(1<<Lock_Set)|(1<<AlarmSet)
			rjmp EndKeyboard1				
Key_A:
			cpi Tmp_A,1<<longkey|1<<s_key1
			brne Key_0

			sbrc ControlFlags,Lock_Set
			ret
		ldi Tmp_E,62
		sts Tone,Tmp_E
			ldi music_Delay,24
			rcall soundon
			sbr ControlFlags,1<<Lock_Set
			rjmp EndKeyboard1				
Key_0:
			cpi Tmp_A,1<<s_key3
			brne Key_1
		ldi Tmp_E,105
		sts Tone,Tmp_E
			sbrs ControlFlags,Lock_Set
			rjmp dispbr_level
			sbr ControlFlags,1<<ChangeSet
			rcall load_limit
			rcall Dec_Set
			st -Y,XL
			rjmp EndKeyboard
Key_1:
			cpi Tmp_A,1<<s_key2
			brne Key_2
		ldi Tmp_E,99
		sts Tone,Tmp_E
			sbrs ControlFlags,Lock_Set
			rjmp Alarm_Select
			sbr ControlFlags,1<<ChangeSet
			rcall load_limit
			rcall Inc_Set
			st -Y,XL;
			rjmp EndKeyboard
Key_2:
			cpi Tmp_A,1<<s_key1
			brne EndKeyb
		ldi Tmp_E,94
		sts Tone,Tmp_E
			sbrs ControlFlags,Lock_Set
			rjmp menu_Select
			mov Tmp_E,choice
			inc Tmp_E
			cpi Tmp_E,5
			sbrc ControlFlags,AlarmSet
			cpi Tmp_E,10
;			sbrc ControlFlags,CtrlSet
;			cpi Tmp_E,5
			brne Key_2_sav
			clr choice
;			sbrc ControlFlags,AlarmSet
;			rjmp clr_contFL
;			sbrc ControlFlags,CtrlSet
;			rjmp clr_contFL
;			rcall calc_week
			sbrc ControlFlags,ChangeSet
			rcall Set_Time;inc_year;

clr_contFL:
			sbrc ControlFlags,CtrlSet
			rcall cont_brbr0
			ldi r16,1
			sts alarm_mask,r16
			ldi ControlFlags,0;1<<Br_disp				;
			rjmp clr_menu
Key_2_sav:
			mov choice,Tmp_E				;
EndKeyboard:  
			cbr MainFlags,1<<off_disp|1<<Alarm_On
			clr r16
			sts alarm0_c,r16
			sts alarm1_c,r16
			ldi r16,10
			sts disp_timer,r16
			ldi music_Delay,9
			rcall soundon
			cbr ControlFlags,1<<Br_disp
			ldi r16,250
			rcall max_bright
EndKeyboard1:
			sbr MainFlags,1<<Disp_Flag
EndKeyb:
		ret

menu_Select:
		ldi r16,1
		sts alarm_mask,r16
		lds r16,DispTask
		cpi r16,5
		brsh clr_menu
		inc r16
term_menu:
;		mov r17,found_devices
;		subi r17,-3		
		cpi r16,3;r17
		brne sav_menu
clr_menu:
		clr r16
sav_menu:
		sts DispTask,r16
	rjmp EndKeyboard

Alarm_Select:
		lds r16,DispTask
		cpi r16,5
		brsh pc+2
		ldi r16,4

		cpi r16,9
		breq Ala_S_0
		cpi r16,6
		brne Ala_S_3
Ala_S_0:
		dec r16
		lds r17,alarm_mask
		lds r18,set_A0_w
		cpi r16,8
		brlo pc+2
		lds r18,set_A1_w
		sbrs r18,0
		rjmp Ala_S_1
		lsl r17
		brne Ala_S_2
		ldi r17,1
Ala_S_1:
		inc r16
Ala_S_2:
		sts alarm_mask,r17
Ala_S_3:
		inc r16
		cpi r16,11
		brne pc+2
		clr r16
		sts DispTask,r16
	rjmp EndKeyboard

dispbr_level:

	rjmp EndKeyboard


bright_return:
;		cbr ControlFlags,1<<Br_disp
		lds ZL,blank_level
		tst ZL
		breq pc+2;max_bright0
		sbr ControlFlags,1<<Br_disp
		sbr MainFlags,1<<off_disp
bright_control:
		clr ZH
		subi ZL, low(-blank_table*2)
		sbci ZH, high(-blank_table*2)
		lpm r16,Z
;		tst r16
;		breq hv_stop
max_bright:
		OUT OCR2,r16
;		ldi r16,(1<<COM0A1)|(0<<COM0A0)|(0<<COM0B1)|(0<<COM0B0)|(1<<WGM01)|(1<<WGM00)
;		out TCCR0A,r16
max_bright0:
	ret
hv_stop:
;		mov blank_target,r16
;		ldi r16,(0<<COM0A1)|(0<<COM0A0)|(0<<COM0B1)|(0<<COM0B0)|(1<<WGM01)|(1<<WGM00)
;		out TCCR0A,r16
;		cbi portd,6
;	ret

;---------------------------------------------------------------------------------------------------|
load_limit:
			clt
			mov ZL,choice
			sbrc ControlFlags,AlarmSet
			subi ZL,-5
			sbrc ControlFlags,CtrlSet
			subi ZL,-15
			lsl ZL
			clr ZH
			push ZL
			subi ZL, low(-DateCell*2)
			sbci ZH, high(-DateCell*2) ; Add
			lpm YL,Z+
			lpm YH,Z
			pop ZL
			clr ZH
			sbrc ControlFlags,AlarmSet
			rjmp Alarmlimit

			cpi ZL,4
			brne ne_mont
			ldd ZL,Y+1
			push ZL
			dec ZL
			subi ZL, low(-cnt_day*2)
			sbci ZH, high(-cnt_day*2) ; Add
			lpm Tmp_B,Z
			ldd Tmp_A,Y+2	;    
			pop ZL
			rcall BCD_to_HEX
			andi Tmp_A,0b00000011	;        
			brne ne_feb
			cpi ZL,2			;  
			brne ne_feb                  
			inc Tmp_B				;  - 
ne_feb:
			ldi Tmp_A,1
			rjmp load_off
ne_mont:
			subi ZL, low(-table_limit*2)
			sbci ZH, high(-table_limit*2) ; Add
			lpm Tmp_B,z+
			lpm Tmp_A,z	
load_off:
			ld XL,Y+
		ret
Alarmlimit:
;			subi ZL,4
			mov Tmp_C,choice
			cpi Tmp_C,6
			brne AlarmlimitB    ; 
			ldi XH,1
			sts alarm_mask,XH
AlarmlimitB:
			cpi Tmp_C,2			; 
			breq AlarmlimitA
			cpi Tmp_C,7			; 
			brne ne_mont
AlarmlimitA:
			lds XH,alarm_mask	; 
			set
			rjmp load_off
Set_limit:



;---------------------------------------------------------------------------------------------------|
;---------------------------------------------------------------------------------------------------|
;   -
;  XL - BCD,Tmp_B -  ,
;Tmp_F -  ,  Tmp_A
Inc_Set:
	brts Shift_Mask
	cp XL,Tmp_B			;   
	brsh clrInc			;  
FuncInc:				; BCD  1
	inc XL				; BCD
	cpi Tmp_B,143
	brne pc+2
	ret
	mov	Tmp_A,XL		;
	andi Tmp_A,0x0F		;  
	cpi Tmp_A,0x0A		;  
	brsh stepInc 		;   >=10
	ret					;   
stepInc:				;   
	andi XL,0xF0		;  ==0
	subi XL,-0x10		;   ++1
	ret					;
clrInc:					;  
	mov XL,Tmp_A		;
	ret					;
;---------------------------------------------------------------------------------------------------|
;   -
;  XL - BCD,Tmp_B -  ,
;Tmp_F -  ,  Tmp_A
Dec_Set:
	brts Set_or_Clr_Bit
	cp XL,Tmp_A			;   
	breq clrDec			;  
FuncDec:				; BCD  1
	cpi Tmp_B,143
	breq hex_143
	mov	Tmp_A,XL		;
	andi Tmp_A,0x0F		;  
	tst Tmp_A			;   =0
	breq stepDec 		;   
hex_143:
	dec XL				;    
	ret					; 
stepDec:				;  
	subi XL,0x07		;      
	ret					;
clrDec:					;  
	mov XL,Tmp_B		;
	ret					;
;---------------------------------------------------------------------------------------------------|
Shift_Mask:
		lsl XH
		brne pc+2
		ldi XH,1
		sts alarm_mask,XH
	ret
Set_or_Clr_Bit:
		eor XL,XH
	ret
DateCell: 	
		.dw time_yy			; 
		.dw time_mnt		; 
		.dw time_dd			; 
		.dw time_hh			;  
		.dw time_mm			; 
		.dw set_A0_h				; [05] 
		.dw set_A0_m				; [06] 
		.dw set_A0_w
		.dw set_A0_s
		.dw set_A0_p
		.dw set_A1_h				; [05] 
		.dw set_A1_m				; [06] 
		.dw set_A1_w
		.dw set_A1_s
		.dw set_A1_p

		.dw set_B_val				; [05] 
		.dw set_B_on				; [06] 
		.dw set_B_off
		.dw set_Inf
		.dw set_Sound

table_limit:
;	High:Low
.db	0x99,0;
.db	0x12,1; 
.db	0x31,1; 
.db	0x23,0;
.db 0x59,0;

.db	0x23,0;
.db 0x59,0;
.db 255,0;
.db 2,0;
.db 5,0;

.db	0x23,0;
.db 0x59,0;
.db 255,0;
.db 2,0;
.db 5,0;

.db	8,0;
.db 143,0;
.db 143,0;
.db 1,0;
.db 3,0;

blank_table:
.db	250,210,170,130,90,60,30,10,0
cnt_day:
.db 0x31,0x28,0x31,0x30,0x31,0x30,0x31,0x31,0x30,0x31,0x30,0x31
;========================================================================================

;========================================================================================



;END FILE
