.include "m8def.inc"
;*************************************************************************************
.include "macro.asm"		; 
.include "define.inc"
;*************************************************************************************
;*************************************************************************************
.cseg
.org 0
; ***** INTERRUPT VECTORS For ATMega48 ****************************************
rjmp RESET			;External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset
reti;rjmp EXT_INT0		;External Interrupt Request 0
reti;rjmp EXT_INT1		;External Interrupt Request 1
rjmp TIMER2_COMP	;Timer/Counter2 Compare Match
rjmp TIMER2_OVF		;Timer/Counter2 Overflow
reti;rjmp TIMER1_CAPT	;Timer/Counter1 Capture Event
rjmp TIMER1_COMPA	;Timer/Counter1 Compare Match A
reti;rjmp TIMER1_COMPB	;Timer/Counter1 Compare Match B
reti;rjmp TIMER1_OVF		;Timer/Counter1 Overflow
rjmp TIMER0_OVF		;Timer/Counter0 Overflow
reti;rjmp SPI_STC		;Serial Transfer Complete
reti;rjmp USART_RXC		;USART, Rx Complete
reti;rjmp USART_UDRE		;USART Data Register Empty
reti;rjmp USART_TXC		;USART, Tx Complete
reti;rjmp ADC_C			;ADC Conversion Complete
reti;rjmp EE_RDY			;EEPROM Ready
reti;rjmp ANA_COMP		;Analog Comparator
reti;rjmp TWI			;Two-wire Serial Interface
reti;rjmp SPM_RDY		;Store Program Memory Ready
; **** END INTERRUPT VECTORS **************************************************
;******************************************************************************
.include "Subbort2.asm"
.include "delay.inc"		;    
;.include "OneWire_Lib.asm"
.include "NIXIE_Disp.asm"
.include "Keyb_333.inc"
.include "i2c_Lib_f.inc"
;*************************************************************************************
;******************************************************************************
RESET:    
; ****   ********************************************************
			cli
			ldi R16,low(RamEnd)      ;  
			out SPL,R16
			ldi R16,high(RamEnd)     ;  
			out SPH,R16

; ****  RAM ***********************************************************
RAM_Flush:	LDI		ZL,Low(SRAM_START)
			LDI		ZH,High(SRAM_START)
			CLR		R16
Flush:		ST 		Z+,R16
			CPI		ZH,High(RAMEND)
			BRNE	Flush
			CPI		ZL,Low(RAMEND)
			BRNE	Flush
			CLR		ZL
			CLR		ZH

;========================================================================================
;  
;========================================================================================
;
;========================================================================================
;PORTA
;			sbi ddra,back_light
;PORTB
;			OUTI ddrb,0;1<<Alarm_Signal
;LCD_PORTD
;			OUTI ddrd,1<<RS|1<<RW|1<<E

			outi ddrb,0b10111111 ; 
			outi ddrd,0b11100000
			outi ddrc,0b00111111
			outi portd,0b00000111

;========================================================================================
			wdr				; 
			ldi r16,0b00011000
			CLRB MCUCR,WDRF,r20	;    
			OUTU WDTCSR,r16
			OUTI WDTCSR,0x0f;   2 



;			wdr				; 
;			CBRI MCUCR,WDRF	;    
;			OUTI WDTCSR,0x0f;   2 
;========================================================================================
;=====================================================================================
			RTC_INIT		;  ds1307
;========================================================================================
;========================================================================================
			ldi ZH,High(DigitS)
			ldi ZL,Low (DigitS)
			ldi temp1,6
			ldi temp,10
			st Z+,temp
			dec temp1
			brne pc-2
			ldi r16,1
			sts alarm_mask,r16
			ldi r16,2
			sts DispTermN,r16
			OUTI disp_timer,1

;			OW_INI
; ****   *****************************************************
			bst MainFlags,Clock_Flag
			LDI	ZL,30		;    	
			CLR	ZH			;      
			DEC	ZL			;  
			ST Z,ZH			;    0
			BRNE PC-2		;      	
			bld MainFlags,Clock_Flag
			sts DispTask,R16
;			rcall SEARCH_ROM_DALLAS
;			rcall calc_week
			rcall cont_brbr0
			ldi cRazr,5
;			ldi r16,81
;			mov blank_target,r16
;========================================================================================
			cli
;========================================================================================
; 0
;========================================================================================
			OUTI TCCR0, (1<<CS02)|(0<<CS01)|(0<<CS00)
			OUTI TCNT0,6
;			OUTI OCR0A,249			; 
;========================================================================================
; 1
;========================================================================================
			OUTI TCCR1A,(0<<COM1A1)|(0<<COM1A0)|(0<<COM1B1)|(0<<COM1B0)|(0<<WGM11)|(0<<WGM10)	
;  = !
;			outi TCCR1B,(0<<ICNC1) |(0<<ICES1) |(0<<WGM13) |(1<<WGM12) |(1<<CS12) |(0<<CS11)|(0<<CS10)
;!   
;			outi TCCR1C,(0<<FOC1A) |(0<<FOC1B)	
; 
;			outi TCNT1H,0
;			outi TCNT1L,0
;  A
;			outi OCR1AH,0x00			; 
			OUTI OCR1AL,0
;  B
;			outi OCR1BH,0x00			; 
;			outi OCR1BL,0x00
; 
;			outi ICR1H,0
;			outi ICR1L,0xFF
;========================================================================================
; 2
;========================================================================================
			OUTI TCCR2, (0<<FOC2)|(0<<WGM20)|(0<<COM21)|(0<<COM20)|(0<<WGM21)|(1<<CS22)|(0<<CS21)|(0<<CS20)
			OUTI TCNT2,0
			OUTI OCR2,250


;========================================================================================
			OUTI TIMSK, (1<<OCIE2)|(1<<TOIE2)|(0<<TICIE1)|(1<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(1<<TOIE0)
;========================================================================================
;          7      6     5      4     3     2      1     0
;TIMSK = TOIE1 OCIE1B OCIE1A ----- ICIE1 OCIE0B TOIE0 OCIE0A 
;			OUTI TIMSK, 0b11000001		;   
;=====================================================================================
;MAIN
;=====================================================================================
MAIN:   	;  
while_Power_ON:   
			wdr
			sei
			sbrc MainFlags,Clock_Flag
			rcall ReadClk			; RTC

;			sbrc MainFlags,Clock_Flag
;			rcall new_day_calc
			sbrc MainFlags,Term_Flag
			rcall term_proc
			sbrc MainFlags,Sckey_Flag
			rcall read4_key;key_proc
			sbrc MainFlags,Blink_Flag
			rcall Blink_Disp
			sbrc MainFlags,Disp_Flag
			rcall work_proc
		rjmp while_Power_ON
;*********************************************************


;=====================================================================================
;     0, 1/125 
;=====================================================================================
TIMER2_OVF:
			push r16
			in r16,SREG;
			push r16
			push temp
			push temp2
			push ZL
			push ZH
			dec cRazr
			brpl din_indik
			ldi cRazr,5
din_indik:		

			mov	temp,cRazr
			SLDP Z,temp,Digits	;   DIGIT.
			ld temp,Z
;			cbi portd,7
;			sbrc temp,7
;			sbi portd,7
			andi temp,0b00001111
			lsl temp
			SLPMS temp,Digit_tab
			in temp1,portb
			in temp2,portd
			andi temp1,0b01000000
			andi temp2,0b00011111
			lpm temp,Z+
			or temp1,temp
			lpm temp,Z
			or temp2,temp
			out portd,temp2      ;   
			out portb,temp1      ;   

			mov	temp,cRazr
			SLPMS temp,Anode_tab
			in temp1,portc
			andi temp1,0b11000000
			lpm temp,Z
			or temp1,temp
			out portc,temp1      ;   
			pop ZH
			pop ZL
			pop temp2
			pop temp
			pop r16
			out SREG,r16
			pop r16
		reti
;=======================================================================================
TIMER2_COMP: 
			push r16
			in r16,SREG;
			push r16
			push temp
			in temp1,portc
			andi temp1,0b11000000
;			ldi temp,0b00111111
;			or temp1,temp
			out portc,temp1      ;   
			pop temp
			pop r16
			out SREG,r16
			pop r16
		reti						;  
;=====================================================================================


;=================================================================
TIMER0_OVF: 
			push r16
			in r16,SREG
			push r16
			push ZL
			push ZH
			OUTI TCNT0,6
			dec FCNT0				; 
			brne EXIT_TIMER0_OVF
;----------------------------------------------------------------
;			inc r8					;  
			ldi FCNT0,125			;1000 
			sbr MainFlags,1<<Clock_Flag;|1<<Disp_Flag;|1<<Term_Flag
;rcall new_day_calc
;----------------------------------------------------------------
EXIT_TIMER0_OVF:
			cpi FCNT0,35
			brne pc+2
			sbr MainFlags,(1<<Blink_Flag)
			sbrs FCNT0,0
			rjmp player
return_player:
			pop ZH
			pop ZL
			pop r16
			out SREG,r16
			pop r16
			reti						;  
;=====================================================================================


player:
			sbr MainFlags,1<<Sckey_Flag ;  

			sbrc MainFlags,Alarm_On
			rjmp player0

			dec music_Delay				;    
			brne return_player					;   
			OUTU TCCR1B,music_Delay;  = CK 64
			cbi Alarm_DDR,Alarm_Sound
			inc music_Delay
		rjmp return_player

player0:
			dec music_Delay
			breq pause
			brpl play
begin:
		movw ZH:ZL,melody_H:melody_L
			cpi ZH,255
			breq sirena

			rcall ReadEEP
			mov music_Delay,Tmp_B
		movw ZH:ZL,store_ZH:store_ZL
			rcall ReadEEP
			cpi Tmp_B,255
			brne cotin
		movw ZH:ZL,melody_H:melody_L
		adiw ZH:ZL,1
		movw store_ZH:store_ZL,ZH:ZL
			rjmp pause
cotin:
			mov store_ZL,ZL
			mov Tmp_A,Tmp_B
			andi Tmp_A,0b11100000
			lsr Tmp_A
			swap Tmp_A
			andi Tmp_B,0b00011111
muz0:
			dec Tmp_A
			brmi muz1
			lsr music_Delay
			breq muz1
			rjmp muz0
muz1:
			tst Tmp_B
			breq pause
			dec Tmp_B
			mov ZL,Tmp_B
			clr ZH
			subi ZL,low (-note_tab2*2)
			sbci ZH,high(-note_tab2*2)
			lpm Tmp_B,Z
play0:
			clr Tmp_A
			OUTU OCR1AH,Tmp_A
			OUTU OCR1AL,Tmp_B
			OUTU TCNT1H,Tmp_A
			OUTU TCNT1L,Tmp_A
			ldi Tmp_B,0b00001011		;  = CK 64
			OUTU TCCR1B,Tmp_B
			sbi Alarm_DDR,Alarm_Sound
		rjmp return_player
pause:
			cbi Alarm_DDR,Alarm_Sound
			clr Tmp_B
			OUTU TCCR1B,Tmp_B
play:
		rjmp return_player
sirena:
			ldi music_Delay,32
			INU Tmp_B,OCR1AL
			cpi Tmp_B,70
			brne pc+3
			ldi Tmp_B,99
		rjmp play0
			ldi Tmp_B,70
		rjmp play0

note_tab2:
.db 238,224,212,200,189,178,168,158
.db 149,141,133,126,118,112,105,99
.db 94,88,83,79,74,70,66,62
.db 59,55,52,49,46,44,41,0

;=================================================================
soundhr:
			lds r16,set_Sound
			sbrs r16,1
			ret
			ldi Tmp_E,62
			sts Tone,Tmp_E
			ldi music_Delay,24
			rjmp sounden
soundon:
			lds r16,set_Sound
			sbrs r16,0
			ret
sounden:
			outi OCR1AH,0
			lds r16,Tone
			OUTU OCR1AL,r16
			outi TCNT1H,0
			outi TCNT1L,0
			outi TCCR1B,0b00001011;  = CK 64
			sbi Alarm_DDR,Alarm_Sound
		ret
;=================================================================
TIMER1_COMPA:
			push r16
			in r16,SREG;
			push r16
			push r17
			ldi r17,1<<Alarm_Sound
			in r16,Alarm_PORT
			eor r16,r17
			out Alarm_PORT,r16      ;   
			pop r17
			pop r16
			out SREG,r16
			pop r16
reti
;=====================================================================================
;=====================================================================================
; EEPROM  Z   Temp 
ReadEEP:
				sbic EECR,EEWE		;  
				rjmp ReadEEP		; 		
				out EEARH,ZH		; H
				out EEARL,ZL		; L
				sbi EECR,EERE		; 
				in  Tmp_B,EEDR		; 
				adiw ZH:ZL,1
			ret						;
;=====================================================================================
; EEPROM  Z   Temp 
;WriteEEP:
;				sbic EECR,EEWE		;  
;				rjmp WriteEEP		; 
;				out EEARH,ZH		; H
;				out EEARL,ZL		; L
;				out EEDR,Tmp_D		; 
;				sbi EECR,EEMWE		;  
;				sbi EECR,EEWE		; 
;			ret						;
;=====================================================================================
;=====================================================================================
;   
;
;========================================================================================
Digit_tab:
; 
;   DDRC          PORTC
;     ---43210    ---43210
;.db 0b00111111, 0b00000000 ;0
;.db 0b00000110, 0b00000000 ;1
;.db 0b00011011, 0b01000000 ;2
;.db 0b00001111, 0b01000000 ;3
;.db 0b00100110, 0b01000000 ;4
;.db 0b00101101, 0b01000000 ;5
;.db 0b00111101, 0b01000000 ;6
;.db 0b00000111, 0b00000000 ;7
;.db 0b00111111, 0b01000000 ;8
;.db 0b00101111, 0b01000000 ;9
;.db 0b00000000, 0b00000000 ;$

Digit_tab2:
;NIXIE
.db	0b00000001,	0b00000000
.db	0b00000000,	0b10000000
.db	0b00000000,	0b01000000
.db	0b00000000,	0b00100000
.db	0b10000000, 0b00000000
.db	0b00000010,	0b00000000
.db	0b00000100,	0b00000000
.db	0b00001000,	0b00000000
.db	0b00010000,	0b00000000
.db	0b00100000,	0b00000000
.db	0b00000000,	0b00000000
.db	0b00000000,	0b00000000
.db	0b00000000,	0b00000000
.db	0b00000000,	0b00000000
.db	0b00000000,	0b00000000
.db	0b00000000,	0b00000000
;=================================================================
Anode_tab:
;   PORTB			DDRB          
;     --543---    --543---
;.db 0b11111110,0b11111101
;.db 0b11111011,0b11110111
;.db 0b11101111,0b11011111
anode_tab2:
.db	0b00000001,	0b00000010
.db	0b00000100,	0b00001000
.db	0b00010000, 0b00100000
;========================================================================================
;   
.include "eeprom.asm"
;========================================================================================

