;========================================================================================
;=====================================================================================
ReadClk:
			cbr  MainFlags,1<<Clock_Flag
			sbrc ControlFlags,ChangeSet
		rjmp End_ReadClk

ReadClk1:
			ldi	I2c_Wait_counter,120
Loop_ReadClk:
			ldi ZH,High(Bufer_RTC)
			ldi ZL,Low (Bufer_RTC)
			clr xl
			ldi I2c_Byte_counter,rom_Fid_A
			ldi I2c_Data,RTC_ADDR_RD
			rcall read_write_i2c
			brtc End_ReadClk
			dec	I2c_Wait_counter
			brne Loop_ReadClk
End_ReadClk:
			sbr MainFlags,1<<Term_Flag;1<<Disp_Flag
no_BL:		
		ret
;=====================================================================================
Set_Time:
			clr I2c_Wait_counter
			sts time_ss,I2c_Wait_counter
Write_Clk:
			ldi	I2c_Wait_counter,120
Loop_Write_Clk:
			ldi ZH,High(Bufer_RTC+rtc_set)	
			ldi ZL,Low (Bufer_RTC+rtc_set)		
			ldi xl,rtc_set
			ldi I2c_Byte_counter,rom_Fid_A-rtc_set

			sbrc ControlFlags,AlarmSet		
			rjmp sav_set
			sbrc ControlFlags,CtrlSet
			rjmp sav_set
			rcall calc_week
			sbiw ZH:ZL,rtc_set
			clr xl
			ldi I2c_Byte_counter,rtc_set-sek
sav_set:
			ldi I2c_Data,RTC_ADDR_WR
			rcall read_write_i2c
			brtc End_Write_Clk
			dec	I2c_Wait_counter
			brne Loop_Write_Clk
End_Write_Clk:
		ret
;=====================================================================================

Blink_Disp:
	cbr MainFlags,(1<<Blink_Flag)
	lds r16,blink
	ldi r17,10
blink_0:
	sbrs r16,0
	rjmp blink_1
	lds r18,DigitS
	andi r18,0x80
	or r18,r17
	sts DigitS,r18
	lds r18,DigitS+1
	andi r18,0x80
	or r18,r17
	sts DigitS+1,r18
blink_1:
	sbrs r16,1
	rjmp blink_2
	lds r18,DigitS+2
	andi r18,0x80
	or r18,r17
	sts DigitS+2,r18
	lds r18,DigitS+3
	andi r18,0x80
	or r18,r17
	sts DigitS+3,r18
blink_2:
	sbrs r16,2
	rjmp blink_3
	lds r18,DigitS+4
	andi r18,0x80
	or r18,r17
	sts DigitS+4,r18
	lds r18,DigitS+5
	andi r18,0x80
	or r18,r17
	sts DigitS+5,r18
blink_3:
	sbrc ControlFlags,Lock_Set
	rjmp clrdisp0
		lds r16,disp_timer
		dec r16
		brne clrdisp
		sts DispTask,r16
		sbrs MainFlags,off_disp
;		sbrc ControlFlags,Br_disp
		rcall bright_return
		ldi r16,1
clrdisp:
		sts disp_timer,r16

clrdisp0:
ret
;=====================================================================================

;
;   
cont_brbr0:
			ldi YL,Low (Bufer_RTC)
			ldi YH,High(Bufer_RTC)
cont_brbr:
			ldd Tmp_A,Y+hour
			rcall BCD_to_HEX
			ldi Tmp_E,6
			mul Tmp_A,Tmp_E
			mov Tmp_C,r0
			ldd Tmp_E,Y+min
			rcall HEX_to_2BCD
			add Tmp_C,Tmp_D

			ldd Tmp_B,Y+bright_H_off
			ldd Tmp_A,Y+bright_H_on
			cp Tmp_A,Tmp_B
			breq fade
			brlo sut_tst
			cp Tmp_C,Tmp_B			
			brlo fade
			cp Tmp_C,Tmp_A
			brsh fade
			rjmp up_br									
sut_tst:
			cp Tmp_C,Tmp_A
			brlo up_br
			cp Tmp_C,Tmp_B			
			brsh up_br
fade:		
			ldd r16,Y+brightness
			sts blank_level,r16
			rjmp end_br_cont
up_br:
			clr r16
			sts blank_level,r16
end_br_cont:
			cbr MainFlags,1<<off_disp
			ret

;     
term_proc:
			cbr MainFlags,(1<<Term_Flag)
			sbr MainFlags,1<<Disp_Flag
control_progg:
			sbrc ControlFlags,Lock_Set
			ret
			ldi YL,Low (Bufer_RTC)
			ldi YH,High(Bufer_RTC)
			ld Tmp_D,Y;+sek
			tst Tmp_D
			breq new_min
			sbrc ControlFlags,Lock_Set
			rjmp yes_alarm3
			sbrs MainFlags,off_disp
			rjmp date4

			ldd r16,Y+Info_Set
			sbrs r16,0
			rjmp date3
			cpi Tmp_D,2
			brne date2
			ldi r16,6
			sts disp_timer,r16
			ldi r16,1
			sts DispTask,r16
date2:
			cpi Tmp_D,4
			brne date3
			ldi r16,2
			sts DispTask,r16
date3:
;			tst found_devices
;			breq date4
;			ldd r16,Y+Info_Set
;			sbrs r16,1
;			rjmp date4
;			cpi Tmp_D,21
;			breq term_0
;			cpi Tmp_D,41
;			brne date4
;term_0:
;			ldi r16,4
;			sts disp_timer,r16
;			lds r16,DispTermN
;			inc r16
;			sts DispTask,r16
;			mov r17,found_devices
;			subi r17,-2		
;			cp r16,r17
;			brne pc+2
;			ldi r16,2
;			sts DispTermN,r16
date4: 
			rjmp yes_alarm3
new_min:
			rcall cont_brbr ;       

;----------------------------------------------------------------------------------
;   
			ldd Tmp_D,Y+weekday
			ldi Tmp_A,1
yes_alarm0:
			lsl Tmp_A
			dec Tmp_D
			brne yes_alarm0			
;----------------------------------------------------------------------------------
;
			ldd Tmp_D,Y+hour
			ldd Tmp_C,Y+Alarm0_hour
			cp Tmp_D,Tmp_C
			brne yes_alarm1
			ldd Tmp_D,Y+min
			ldd Tmp_C,Y+Alarm0_min
			cp Tmp_D,Tmp_C
			brne yes_alarm1
			ldd Tmp_D,Y+Alarm0_weekday
			sbrs Tmp_D,0
			rjmp yes_alarm1
			cbr Tmp_D,1<<0
			and Tmp_D,Tmp_A
			breq yes_alarm1
			ldd Tmp_D,Y+Alarm0_povtor
			inc Tmp_D
Alarm0_st:
			dec Tmp_D
			sts alarm0_c,Tmp_D
			ldi Tmp_D,5
			sts alarm0_cnt,Tmp_D

		ldd ZL,Y+Alarm0_sound		;  1 
		rcall sound_calc

;			sbr MainFlags,1<<Alarm_On
			rjmp yes_alarm3
;----------------------------------------------------------------------------------
yes_alarm1:
			ld Tmp_D,Y
			ldd Tmp_C,Y+Alarm1_hour
			cp Tmp_D,Tmp_C
			brne yes_alarm2
			ldd Tmp_D,Y+min
			ldd Tmp_C,Y+Alarm1_min
			cp Tmp_D,Tmp_C
			brne yes_alarm2
			ldd Tmp_D,Y+Alarm1_weekday
			sbrs Tmp_D,0
			rjmp yes_alarm2
			cbr Tmp_D,1<<0
			and Tmp_D,Tmp_A
			breq yes_alarm2
			ldd Tmp_D,Y+Alarm1_povtor
			inc Tmp_D
Alarm1_st:
			dec Tmp_D
			sts alarm1_c,Tmp_D
			ldi Tmp_D,5
			sts alarm1_cnt,Tmp_D

		ldd ZL,Y+Alarm1_sound		;  2 
		rcall sound_calc

;			sbr MainFlags,1<<Alarm_On
			rjmp yes_alarm3
;----------------------------------------------------------------------------------
;  
yes_alarm2:
			lds Tmp_D,alarm0_c
			tst Tmp_D
			breq yes_alarm21
			lds Tmp_A,alarm0_cnt
			dec Tmp_A
			breq Alarm0_st
			sts alarm0_cnt,Tmp_A
yes_alarm21:
			lds Tmp_D,alarm1_c
			tst Tmp_D
			breq yes_alarm22
			lds Tmp_A,alarm1_cnt
			dec Tmp_A
			breq Alarm1_st
			sts alarm1_cnt,Tmp_A
yes_alarm22:
			ldi music_Delay,1
			ldd Tmp_D,Y+min
			tst Tmp_D
			brne no_hr_signal
			rcall soundhr
			rjmp yes_alarm3
no_hr_signal:
			cbr MainFlags,(1<<Alarm_On);|(1<<Alarm_Signal)
yes_alarm3:
		ret
;----------------------------------------------------------------------------------

;----------------------------------------------------------------------------------
sound_calc:
		lsl ZL
		subi ZL,-melody_begin
		clr ZH
		rcall ReadEEP
		mov melody_L,Tmp_B
		rcall ReadEEP
		mov melody_H,Tmp_B
		movw ZH:ZL,melody_H:melody_L
		adiw ZH:ZL,1
		movw store_ZH:store_ZL,ZH:ZL
		ldi r16,60
		sts disp_timer,r16
		cbr ControlFlags,1<<Br_disp
		cbr MainFlags,1<<off_disp
		ldi r16,250
		rcall max_bright
		sbr MainFlags,1<<Alarm_On
	ret
;----------------------------------------------------------------------------------
//______    (  DANKO c  "" )))  )_________
;unsigned char Day_week (void) 
;{
;unsigned char y, m, myday;
;
;   y = god;
;   m = mesec;
;
;   if (m > 2) { m -= 2;       }
;   else       { m += 10; y--; }
;
;   myday = ((chislo + y + (y>>2) + ((31 * m) / 12)) % 7);
;   
;   if (myday)  return myday;  else  return  7;
;}
;========================================================================================
BCD_to_HEX:
			mov Tmp_D,Tmp_A
			andi Tmp_A,0x0f
			swap Tmp_D
			andi Tmp_D,0x0f
			ldi Tmp_E,10
			mul Tmp_D,Tmp_E
			add Tmp_A,r0
		ret
calc_week:
			lds Tmp_A,time_mnt
			rcall BCD_to_HEX
			push Tmp_A
			lds Tmp_A,time_yy
			rcall BCD_to_HEX
			push Tmp_A
			lds Tmp_A,time_dd
			rcall BCD_to_HEX


			mov Tmp_C,Tmp_A;time_dd
			pop Tmp_B;,time_yy
			pop Tmp_A;,time_mnt
			cpi Tmp_A,3
			brlo calc_week0
			subi Tmp_A,2
			rjmp calc_week1
calc_week0:
			subi Tmp_A,-10
			dec Tmp_B
calc_week1:
			ldi Tmp_E,31
			mul Tmp_E,Tmp_A
			mov Tmp_D,r0
			mov Tmp_E,r1
			ldi Tmp_A,-1		; 
calc_week2:						; 
			inc Tmp_A			; 
			subi Tmp_D,low(12)	;1
			sbci Tmp_E,High(12)	;1
			brsh calc_week2		;   

			add Tmp_A,Tmp_B
			lsr Tmp_B
			lsr Tmp_B
			add Tmp_A,Tmp_B
			add Tmp_A,Tmp_C
calc_week3:
			subi Tmp_A,7
			brsh calc_week3		;   
			subi Tmp_A,-7
			brne calc_week4
			ldi Tmp_A,7
calc_week4: 
			sts time_dw,Tmp_A
		ret

;========================================================================================
;========================================================================================

