	.equ	sCR=0x0d
	.equ	sLD=0x0a
;=============================================================================
;Section RTC Define 
;=============================================================================
;RTC Const
.equ	RTC_ADDR_WR = 0xD0 ;addr device,r/w=0
.equ	RTC_ADDR_RD = 0xD1 ;addr device,r/w=1
;.equ	EEP_ADDR_WR = 0xA0 ;addr device,r/w=0
;.equ	EEP_ADDR_RD = 0xA1 ;addr device,r/w=1
;------------------------------------------------------------------------------
;RTC macro
.macro RTC_INIT
		rcall ReadClk1
		ldi ZH,High(Bufer_RTC)
		ldi ZL,Low (Bufer_RTC)
		ld Tmp_D,Z				; Tmp_D   
		ldd Tmp_E,Z+7			; Tmp_E   
		cpi Tmp_D,$80			; Tmp_D  ,     128
		brsh setsec				;  
		cpi Tmp_E,$10			; Tmp_E  ,     
		brne st_clk				;   
		rjmp setRAM				;
setsec:							;
		ldi r16,1
		sts time_dd,r16
		sts time_mnt,r16 
		ldi r16,0x12
		sts time_yy,r16
		rcall Set_Time			;  = 0
st_clk:							;
		ldi ZH,High(Bufer_RTC+rtc_set)
		ldi ZL,Low (Bufer_RTC+rtc_set)
		ldi Tmp_D,rom_Fid_A-rtc_set
		ldi Tmp_E,0b00010000	; SQW   1
St_loop:
		st Z+,Tmp_E
		clr Tmp_E
		dec Tmp_D
		brne St_loop

		ldi r16,7
		sts set_A0_h,r16
		ldi r16,0x12
		sts set_A1_h,r16

		ldi r16,0b11111110
		sts set_A0_w,r16
		sts set_A1_w,r16
		ldi r16,36
		sts set_B_off,r16
		ldi r16,1
		sts set_Inf,r16
		ldi r16,3
		sts set_Sound,r16

		sbr ControlFlags,1<<AlarmSet
		rcall Write_Clk			;
setRAM:							;
.endmacro
;=============================================================================
;Port configuration
;=============================================================================
.equ	PORT_X	= PORTd 
.equ	DDR_X	= DDRd
.equ	PIN_X	= PINd
.equ	pSCL	= 3 
.equ	pSDA	= 4

;.equ	pSCL	= 5 
;.equ	pSDA	= 4

;.equ	pLED	= 6
;==============================================================================
;End RTC Define
;==============================================================================
;=============================================================================
;Section 1-Wire Define 
;=============================================================================
;------------------------------------------------------------------------------
	.equ	disable_Search_ROM		=1  ;    
;	.equ	disable_read_RAM_1WL	=1
;	.equ	disable_Write_ROM_1WL	=1
;=====================================================================================
;	.equ	Search_result			=  				;
	.equ	Search_direction 		= SREG_T
;	.equ	LastDeviceFlag			=  
;=====================================================================================
	.def	Bit_counter				=R16			;
;-------------------------------------------------------------------------------------
	.def	Byte_counter			=R17			;   
	.def	Rom_byte_mask			=R17			;  
;-------------------------------------------------------------------------------------
	.def	Wait_counter			=R18			;Tmp_C
	.def	Data_byte				=R19			;Tmp_D
	.def	Id_bit_number			=R20			;Tmp_E  ID
;	.def	Search_flags			=  R21			;Tmp_F
;	.def	Rom_byte_number			= 
;=====================================================================================
	.def	temp_crc8				=R2				;Mem_A
	.def	crc8					=R3				;Mem_C
	.def	Last_zero				=R4				;Mem_B
	.def	LastDiscrepancy			=R5				;Mem_D
;	.def	LastFamilyDiscrepancy	=  R6				;Mem_F
	.def	found_devices			=R6				;Mem_G
;=====================================================================================

;1-Wire Const
.equ XTAL_Clock = 8000000
.equ OW_SPEED = (((XTAL_Clock/100000)-11)/3)	;10  XTAL=8MHz, 
.equ number_device = 2
.equ RD_SCRATCHPAD_Bytes = 2
.equ RD_SCRATCHPAD_const = ((9-RD_SCRATCHPAD_Bytes)+1)
.equ size_device = (8+RD_SCRATCHPAD_Bytes)
.equ size_bufer = (number_device*size_device)

;.equ size_termo = (number_device*RD_SCRATCHPAD_Bytes)
.equ realtime_search=1
.equ own_delays=1
;      DS1820
;  - Send_1w []
;=============================================================================
.equ	CMD_SEARCH_ROM = 0xF0	;      
.equ	CMD_READ_ROM = 0x33		;    
.equ	CMD_MATCH_ROM = 0x55	;      
.equ	CMD_SKIP_ROM = 0xCC 	;      
								;    
.equ	CMD_ALARM_SEARCH = 0xEC	;  ,    ALARM 
								;(    CMD_SERCH_ROM)
.equ	CMD_CONVERT_T = 0x44	;   
.equ	CMD_W_SCRATCHPAD = 0x4E	;     ()
.equ	CMD_R_SCRATCHPAD = 0xBE	;    ()
.equ	CMD_C_SCRATCHPAD = 0x48	;    EEPROM 
.equ	CMD_RECALL_EE = 0xB8	;     EEPROM   ALARM
.equ	CMD_READ_POWER = 0xB4	; ,      
								;  
;--------------------------------------------------------------------------------------
;1-Wire macro
.macro	WAIT_1US
	.if XTAL_Clock <= 4000000
		nop			;  nop  
		nop
		nop
		nop        
	.else
		rcall delay1us
	.endif
.endmacro

.macro	SEND_1W
	ldi	Data_byte, @0			;  
	rcall Write_Byte_1W			; 
.endmacro

;======================================================================================
;Port configuration
;======================================================================================
.equ	OW_PORT	= PORTd			;  ,   1-Wire
.equ	OW_PIN	= PINd			;  ,   1-Wire
.equ	OW_DDR	= DDRd			;  ,   1-Wire
.equ	OW_DQ	= 3				;  ,   1-Wire
.equ	OW_PWUP	= 4				;  ,   1-Wire
;======================================================================================
;End 1-Wire Define
;======================================================================================
;Section general Define 
;======================================================================================
.equ	T2_OFF		=$00		; timer 2 divider values
.equ	T2_DIV1		=$01		
.equ	T2_DIV8		=$02	
.equ	T2_DIV32	=$03
.equ	T2_DIV64	=$04	
.equ	T2_DIV128	=$05
.equ	T2_DIV256	=$06	
.equ	T2_DIV1024	=$07

	.def	Temp1=R16
	.def	Temp2=R17
	.def	Temp3=R18
	.def	Temp4=R19
	.def	Temp=R20
;-----------------------------------------------------------------------
	.def	Tmp_A=R16		; 
	.def	Tmp_B=R17		; 
	.def	Tmp_C=R18		; 
	.def	Tmp_D=R19		; .
	.def	Tmp_E=R20		; .
;-----------------------------------------------------------------------
	.def	choice	=R7
;	.def	alarm0_c=R8
	.def	blank_target=R9
	.def	melody_L=R10
	.def	melody_H=R11
	.def	store_ZL=R12
	.def	store_ZH=R13
	.def	T_OCR0A=R14
	.def	STORED_SREG=R15 
	.def	FCNT0=R21
	.def	cRazr=R22
	.def	music_Delay=R23

;	  
;-----------------------------------------------------------------------
	.def MainFlags	= R24

	.equ Clock_Flag	= 0
	.equ Term_Flag	= 1
	.equ Disp_Flag	= 2
	.equ Blink_Flag	= 3
	.equ Alarm_On	= 4
	.equ off_disp	= 5
	.equ Sckey_Flag	= 7
;-----------------------------------------------------------------------
;	 
;-----------------------------------------------------------------------
	.def ControlFlags=R25
	.equ Lock_Set	= 0
	.equ AlarmSet	= 1
	.equ CtrlSet	= 2
	.equ ChangeSet	= 3
	.equ Br_disp	= 4
	.equ PWUP_Flag	= 5

;	.equ ChangeTerm	= 7
;-----------------------------------------------------------------------
.equ	Alarm_PORT		= PORTb
.equ	Alarm_DDR		= DDRb

.equ	Alarm_Sound		= 6

.dseg
key:		.byte 1
key_d:		.byte 3
timerkey:	.byte 1
DispTask:	.byte 1
blink:		.byte 1
disp_timer:	.byte 1
DispTermN:	.byte 1
Tone:		.byte 1
alarm_mask:	.byte 1
alarm0_cnt:	.byte 1
alarm1_cnt:	.byte 1
alarm0_c:	.byte 1
alarm1_c:	.byte 1
blank_level:.byte 1

DigitS:		.byte 6
DigitS_old:	.byte 6
.cseg


.equ	sek			= 0 
.equ	min			= 1 
.equ	hour		= 2
.equ	weekday		= 3
.equ	date		= 4
.equ	month		= 5
.equ	year		= 6
.equ	rtc_set		= 7



;.equ	hour			= 0 
;.equ	min				= 1 
;.equ	sek				= 2
;.equ	date			= 3
;.equ	month			= 4
;.equ	year			= 5
;.equ	weekday			= 6

.equ	Alarm0_hour		= 8
.equ	Alarm0_min		= 9 
.equ	Alarm0_weekday	= 10
.equ	Alarm0_sound	= 11
.equ	Alarm0_povtor	= 12

.equ	Alarm1_hour		= 13
.equ	Alarm1_min		= 14 
.equ	Alarm1_weekday	= 15
.equ	Alarm1_sound	= 16
.equ	Alarm1_povtor	= 17


.equ	brightness		= 18
.equ	bright_H_on		= 19
.equ	bright_H_off	= 20
.equ	Info_Set		= 21
.equ	Sound_Set		= 22

.equ	rom_Fid_A		= 23
.equ	rom_crc_A		= (rom_Fid_A+7)
.equ	temperature_AL	= (rom_Fid_A+8)
.equ	temperature_AH	= (rom_Fid_A+9)

.equ	rom_Fid_B		= (rom_Fid_A+10)
.equ	rom_crc_B		= (rom_Fid_B+7)
.equ	temperature_BL	= (rom_Fid_B+8)
.equ	temperature_BH	= (rom_Fid_B+9)

.equ	Bufer_RTC = time_ss
.equ	clock_BCD = Bufer_RTC
.dseg
time_ss:		.byte 1            ; 
time_mm:		.byte 1            ; 
time_hh:		.byte 1            ;  
time_dw:		.byte 1            ;  
time_dd:		.byte 1            ; 
time_mnt:		.byte 1            ; 
time_yy:		.byte 1            ; 
time_set:		.byte 1            ; 

set_A0_h:		.byte 1            ; 
set_A0_m:		.byte 1            ; 
set_A0_w:		.byte 1            ; 
set_A0_s:		.byte 1
set_A0_p:		.byte 1

set_A1_h:		.byte 1            ; 
set_A1_m:		.byte 1            ; 
set_A1_w:		.byte 1            ; 
set_A1_s:		.byte 1
set_A1_p:		.byte 1

set_B_val:		.byte 1            ; 
set_B_on:		.byte 1            ; 
set_B_off:		.byte 1            ; 
set_Inf:		.byte 1
set_Sound:		.byte 1

Buffer_rom:	.byte size_bufer
.cseg

;END FILE

