;=======================================================================\
;-------------       I2C -------------|
;=======================================================================/
;  ..     :)
; BVS  2011.
;========================================================================
	.def	I2c_Bit_counter=R16
	.def	I2c_Byte_counter=R17
	.def	I2c_Wait_counter=R18			; 
	.def	I2c_Data=R19
;------------------------------------------------------------------------
;.equ 	Word_addres=1  AT24cXX    !!!     
;.equ 	Inc_addres=1    XL(XL:XH)      	
;------------------------------------------------------------------------
; I2c_Data   + R/W
; I2c_Byte_counter   0-255
; XL     0-255,
;  XH:XL  Word_addres=1  0-65535
; ZH:ZL        
read_write_i2c:
			cbi	PORT_X,pSDA					;PortSDA=0
			cbi	PORT_X,pSCL					;PortSCL=0
			push I2c_Data					;  
			rcall start						;START
			cbr I2c_Data,0b00000001			;addr device,r/w=0
			rcall write						; 
			brcs Err_1						;C=1 ERROR ,      
											;     
.ifdef Word_addres
			cpi I2c_Data,RTC_ADDR_WR		; I2c_Data    -   "write"
			breq set_low_addr				;  RTC       
			mov I2c_Data,XH					;
			rcall write						;    XH
			brcs Err_1						;C=1 ERROR
set_low_addr:								;RTC only low addres
.endif				
			mov I2c_Data,XL					;
			rcall write						;    XL
Err_1:
			pop I2c_Data					;   
			brcs Err_11						;C=1 ERROR
			sbrs I2c_Data,0					; r/w=1       
			rjmp write_i2c					; r/w=0      .
			rcall start						;
			rcall write						;
			brcs Err_11						;C=1 ERROR
loop_read_i2c:								;
			clt								;  ACK   SPEG_T 
			dec I2c_Byte_counter			;  
			brmi Stop_i2c					; -1    STOP
			breq pc+2						; 0     
			set								;   ACK
			rcall read						; 
			st Z+,I2c_Data					;   
.ifdef Inc_addres							;
.ifdef Word_addres							;
			adiw XH:XL,1					;   
.else										;
			inc XL							;
.endif										;
.endif				
			rjmp loop_read_i2c	  			; 
write_i2c:									;
			ld I2c_Data,Z+					;       
			rcall write						;
			brcs Err_11						;C=1 ERROR
.ifdef Inc_addres							;
.ifdef Word_addres							;
			adiw XH:XL,1					;  
.else										;
			inc XL							;
.endif										;
.endif					
			dec I2c_Byte_counter						;  
			brne write_i2c					; 
Stop_i2c:									;
			rcall stop						;STOP
Err_11:										;
			clt								;SPEG_T = falce
			brcc pc+2						;      STOP 
			set								;SPEG_T = true
		ret									;
;=======================================================================/
read:							;   I2c_Data
			ser I2c_Data			; t=1 ->  ACK, t=0   ACK
			rjmp read0
write:							;   I2c_Data
			clt
read0:
			ldi	I2c_Bit_counter,8			; 
next_bit:
			cli
			sbrc I2c_Data,7			;  SDA MSB  I2c_Data
			cbi	DDR_X,pSDA		;1=SDA
			cbi	DDR_X,pSCL		;1=SCL
			rcall delay			;4 us,  XTAL Clock 8  F_SCL==100 
			lsl	I2c_Data			;  I2c_Data
			sbic PIN_X,pSDA		; SDA==1 
			sbr I2c_Data,1			; LSB   I2c_Data
			sbi	DDR_X,pSCL 		;0=SCL
			rcall delay			;4 us
			sbi	DDR_X,pSDA 		;0=SDA
			dec	I2c_Bit_counter
			brne next_bit		; 
			brts pc+2			;if SPEG_T==1 then SDA=1 //  ACK
			cbi	DDR_X,pSDA		;else SDA=0				 // ACK
			cbi	DDR_X,pSCL		;SCL=1
			rcall delay			;4 us
			clc					;SPEG_C = falce
			sbic PIN_X,pSDA		;     ACK
			sec					;SPEG_C = true //ACK   
			sbi	DDR_X,pSCL		;SCL=0
			rcall delay			;4 us
			sbi	DDR_X,pSDA		;SDA=0
			sei
		ret
;=======================================================================/
start:
			cbi	DDR_X,pSDA
			cbi	DDR_X,pSCL
			rcall delay
			sbis PIN_X,pSDA
			rjmp start
			sbis PIN_X,pSCL
			rjmp start
			sbi	DDR_X,pSDA ;0=SDA
			rcall delay
			sbi	DDR_X,pSCL ;0=SCL
			rcall delay
		ret
;=======================================================================/
stop:
			sbi	DDR_X,pSDA
			sbi	DDR_X,pSCL
			rcall delay
			cbi	DDR_X,pSCL ;1=SCL
			rcall delay
			cbi	DDR_X,pSDA ;1=SDA
			rcall delay
			clc
			sbic PIN_X,pSDA
		ret
			sbic PIN_X,pSCL
		ret
			sec
		ret
;=====================================================================================
;
;=====================================================================================

