.macro	stsi		;save_immediate <SRAM_cell>,<k>
	ldi Temp,@1
	sts @0,Temp
.endmacro

.macro	stss		;save_immediate <SRAM_cell>,<SRAM_cell>
	lds Temp,@1
;	andi temp,0b00001111
	sts @0,Temp
.endmacro

.macro	rdm
	ldi ZH,High(@0*2)
	ldi ZL,Low(@0*2)
	add ZL,Temp1
	adc ZH,Temp2
	lpm
	mov Temp1,r0
.endmacro

.macro	pushf
;   Temp     
			push Temp
			in Temp,SREG
			push Temp
			push Temp1
			push Temp2
			push Temp3
			push Temp4
			push ZL
			push ZH
			push YL
			push YH
			push XL
			push XH

.endmacro

.macro	popf
;   Temp     

			pop XH
			pop XL
			pop YH
			pop YL
			pop ZH
			pop ZL
			pop Temp4
			pop Temp3
			pop Temp2
			pop Temp1
			pop Temp
			out SREG,Temp
			pop Temp
.endmacro

.macro	ldii		;save_immediate <SRAM_cell>,<k>
	ldi Temp,@1
	mov @0,Temp
.endmacro

;******************************************************************************
; INU	Rd,Reg			     /
; OUTI	Reg,K			( R16)      /
; OUTU	Reg,Rd			     /
; SETBM	Reg,b			       /
; SETB	Reg,b,Rd		       /
; CLRBM	Reg,b			  cntr     /
; CLRB	Reg,b,Rd		       /
; INVBM	Reg,b			       /
; INVB	Reg,b,Rd1,Rd2	       /
; PUSHF					 SREG  R16  
; POPF					 SREG  R16  
;
.macro   OUTIa           
      ldi   Tmp_E,@1
   .if @0 < 0x40
      out   @0,Tmp_E         
   .else
      sts   @0,Tmp_E
   .endif
.endm

.macro	SBRI
		.if @0<0x20
		sbi	@0,@1
		.else
			.if	@0<0x40
			in Tmp_E,@0
			sbr Tmp_E,1<<@1
			out @0,Tmp_E
			.else
			lds Tmp_E,@0
			sbr Tmp_E,1<<@1
			sts @0,Tmp_E
			.endif
		.endif
.endmacro

.macro	CBRI
		.if @0<0x20
		cbi	@0,@1
		.else
			.if	@0<0x40
			in Tmp_E,@0
			cbr Tmp_E,1<<@1
			out @0,Tmp_E
			.else
			lds Tmp_E,@0
			cbr Tmp_E,1<<@1
			sts @0,Tmp_E
			.endif
		.endif
.endmacro



   .macro   INU
   	.if	@1 < 0x40
      	in	@0,@1         
	.else
      	lds	@0,@1
   	.endif

   .endm
   .macro   OUTI           
      ldi   R16,@1
   .if @0 < 0x40
      out   @0,R16         
   .else
      sts   @0,R16
   .endif
   .endm
;.............................................................
   	.macro  OUTU        
   	.if	@0 < 0x40
      	out	@0,@1         
	.else
      	sts	@0,@1
   	.endif
   	.endm
;.............................................................
;SET BIT with stack
	.MACRO	SETBM 
		.if @0<0x20
		SBI	@0,@1
		.else
			.if	@0<0x40
		PUSH R20
		IN 	R20,@0
		sbr R20,1<<@1
		OUT @0,R20
		POP	R20
			.else
		PUSH R20
		LDS R20,@0
		sbr	R20,1<<@1
		STS	@0,R20
		POP	R20
			.endif
		.endif
	.ENDM
;.............................................................
;SET BIT with REG
	.MACRO	SETB
		.if @0 < 0x20		; Low IO
		SBI		@0,@1
		.else
			.if	@0<0x40		; High IO
		IN		@2,@0
		sbr		@2,1<<@1
		OUT		@0,@2
			.else			; Memory
		LDS		@2,@0
		sbr		@2,1<<@1
		STS		@0,@2
			.endif
		.endif
	.ENDM

;Clear BIT with STACK ============================================
	.MACRO	CLRBM 
	.if @0<0x20
	CBI	@0,@1
	.else
		.if @0<0x40
	PUSH R20
	IN	R20,@0
	cbr R20,1<<@1
	OUT	@0,R20
	POP	R20
		.else
	PUSH R20
	LDS	R20,@0
	cbr R20,1<<@1
	STS	@0,R20
	POP	R20
		.endif
	.endif
	.ENDM	
;.............................................................
;Clear BIT with REG
	.MACRO	CLRB
		.if @0 < 0x20		; Low IO
		CBI		@0,@1
		.else
			.if	@0<0x40		; High IO
		IN		@2,@0
		cbr	@2,(1<<@1)
		OUT		@0,@2
			.else			; Memory
		LDS		@2,@0
		cbr	@2,(1<<@1)
		STS		@0,@2
			.endif
		.endif
	.ENDM



 
;---------------------------------------------------------------------------	
	.MACRO	INVB
	.if	@0 < 0x40
	IN	@2,@0
	LDI	@3,1<<@1
	EOR	@3,@2
	OUT	@0,@3
	.else
	LDS	@2,@0
	LDI	@3,1<<@1
	EOR	@2,@3
	STS	@0,@2
	.endif
	.ENDM
 
;---------------------------------------------------------------------------	
	.MACRO	INVBM
	.if	@0 < 0x40
	PUSH	R16
	PUSH	R17
	IN	R16,@0
	LDI	R17,1<<@1
	EOR	R17,R16
	OUT	@0,R17
	POP	R17
	POP	R16
	.else
	PUSH	R16
	PUSH	R17
	LDS	R16,@0
	LDI	R17,1<<@1
	EOR	R17,R16
	STS	@0,R17
	POP	R17
	POP	R16
	.endif
	.ENDM
;---------------------------------------------------------------------------		
;	.MACRO PUSHF
;		PUSH	R16
;		IN	R16,SREG
;		PUSH	R16
;	.ENDM
 
;---------------------------------------------------------------------------	 
;	.MACRO POPF
;		POP	R16
;		OUT	SREG,R16
;		POP	R16
;	.ENDM
;---------------------------------------------------------------------------		
;USART INIT
;		.equ MainClock 		= 8000000				; CPU Clock
;		.equ baudrate 		= 9600

.MACRO	USART_INIT

.equ bauddivider = MainClock/(16*baudrate)-1
			
OUTI UBRR0L,low(bauddivider)
OUTI UBRR0H,high(bauddivider)
OUTI UCSR0A, 0
OUTI UCSR0B,(0<<RXCIE0)|(0<<TXCIE0)|(0<<UDRIE0)|(0<<UCSZ02)|(1<<RXEN0)|(1<<TXEN0)
OUTI UCSR0C,(0<<UMSEL01)|(0<<UMSEL00)|(0<<UPM01)|(0<<UPM00)|(0<<USBS0)|(1<<UCSZ01)|(1<<UCSZ00)|(0<<UCPOL0)

.ENDM
;---------------------------------------------------------------------------	
.macro	SLPM		;    SLPM Rd,Rr,k
mov ZL,@1
clr ZH
subi ZL,Low(-@2*2)
sbci ZH,High(-@2*2)
lpm @0,Z
.endmacro


.macro	SLPMS		; Z   SLP Rr,k
mov ZL,@0
clr ZH
subi ZL,Low(-@1*2)
sbci ZH,High(-@1*2)
.endmacro

.macro	SLDP		;    SLD Rd,Rr,<SRAM_cell>
mov @0L,@1
clr @0H
subi @0L,Low(-(@2))
sbci @0H,High(-(@2))
.endmacro


.macro	ASSR_Wait
		lds	R20,ASSR				; wait till all busy bits clear
		andi R20,0x1f
		brne pc-3
.endmacro

